package eleicao

data class Candidato(val nome:String, val votos:Int, val eleito:Boolean, val partido:Partido?, val coligacao:Coligacao?): Comparable<Candidato> {
    override fun compareTo(other: Candidato): Int {
        if(this.votos > other.votos) return -1
        if(this.votos < other.votos) return 1
        if(this.votos < other.votos) return 1
        return 0
     }

    override fun toString(): String {
        var resp: String = "${this.nome} ( ${this.partido?.nome} , ${this.votos} votos)"
        if (this.coligacao != null) resp += " - Coligacao: ${this.coligacao.getNome()}"
        return resp
    }
}