package eleicao
import kotlin.collections.*


class Coligacao:Comparable<Coligacao> {
    val partidos:MutableList<Partido> = mutableListOf()


    constructor(partidos: List<String>){
        for(p:String in partidos)
            this.partidos.add(Partido(p))

    }

    override fun compareTo(other:Coligacao):Int{
        if(this.getVotos()> other.getVotos()) return -1
        if(this.getVotos() < other.getVotos()) return 1
        return 0
    }

    fun getNome():String{
        var resp:String = ""
        for(p:Partido in this.partidos)
            resp+= p.nome + " / "
        resp = resp.substring(0, resp.lastIndexOf(" / "))
        return resp
    }

    fun getVotos():Int{
        var resp:Int = 0
        for(p:Partido in this.partidos)
            resp+= p.getVotos()
        return resp
    }

    fun getEleitos():Int{
        var resp = 0
        for(p:Partido in this.partidos)
            resp+= p.getEleitos()
        return resp
    }

    override fun toString(): String {
        return "Coligacao: ${this.getNome()}, ${this.getVotos()} votos, ${this.getEleitos()} candidatos eleitos"
    }

    fun comparaNome(nomes:Array<String>):Boolean{
        var comp = ""
        for(nome in nomes)
            comp += "$nome / "
        comp = comp.substring(0, comp.lastIndexOf(" / "))

        return this.getNome().equals(comp)
    }

    fun comparaNome(nomes:String?):Boolean{
        return this.getNome().equals(nomes)
    }
}