package eleicao
import kotlin.collections.*
import java.io.*


class Eleicao{
    val coligacoes:MutableList<Coligacao> = mutableListOf()
    val candidatos:MutableList<Candidato> = mutableListOf()
    val partidos:MutableList<Partido> = mutableListOf()

    constructor(arquivo:BufferedReader){
        var linha:String? = arquivo.readLine()
        var nomeCandidato: String
        var nomePartido: String
        var nomeColigacao: String?
        var partidoColigacao: List<String>
        var colig: Coligacao? = null
        var votos: Int
        var eleito: Boolean

        linha=arquivo.readLine()
        while(linha != null){
            val entradas = linha.split(";")

            eleito = entradas[0].contains("*")
            nomeCandidato = entradas[2]
            if (entradas[3].contains("-")){
                partidoColigacao = entradas[3].split(" - ")
                nomePartido = partidoColigacao[0];
                nomeColigacao = partidoColigacao[1];
            }else{
                nomePartido=entradas[3];
                nomeColigacao = null;
            }

            votos = entradas[4].replace(".","").toInt()

            var existePart = false
            for(p in partidos) if (p.nome.equals(nomePartido)) existePart = true
            if(!existePart){
                if(nomeColigacao != null){
                    colig = Coligacao(nomeColigacao.split(" / "))
                    this.coligacoes.add(colig)
                    for(p:Partido in colig.partidos)
                        partidos.add(p)

                }
                else{
                    val p = Partido(nomePartido)
                    this.partidos.add(p)
                    colig?.partidos?.add(this.partidos.last())
                }
            }

            var part:Partido? = null
            for(p:Partido in partidos) if (p.nome.equals(nomePartido)) part = p

            colig = null
            for(c:Coligacao in coligacoes) if(c.comparaNome(nomeColigacao)) colig = c
            candidatos.add(Candidato(nomeCandidato, votos, eleito, part, colig))
            candidatos.last().partido?.candidatos?.add(candidatos.last())
            linha=arquivo.readLine()
        }

    }

    fun imprimeEleicao(arquivo:OutputStreamWriter) {
        val cs: MutableList<Candidato> = mutableListOf()
        cs.addAll(candidatos)
        val ps: MutableList<Partido> = mutableListOf()
        ps.addAll(partidos)
        val cls: MutableList<Coligacao> = mutableListOf()
        cls.addAll(coligacoes)
        var nVagas = 0
        var nVotos = 0

        for (c in cs) if (c.eleito) nVagas++
        arquivo.write("Número de vagas: $nVagas")
        arquivo.write("\n\nVereadores eleitos:")
        for (i in 0..(nVagas - 1))
            arquivo.write("\n ${i + 1} - ${cs.get(i)}")

        //Impressão dos nVagas-mais votados
        arquivo.write("\n\nCandidatos mais votados (em ordem decrescente de votação e respeitando número de vagas):")
        cs.sort()

        for (i in 0..nVagas - 1) arquivo.write("\n${(i + 1)}  - ${cs[i]}")

        //Impressao dos mais votados nao eleitos
        arquivo.write("\n\nTeriam sido eleitos se a votação fosse majoritária, e não foram eleitos:")
        arquivo.write("\n(com sua posição no ranking de mais votados")
        for (c in cs) {
            var d = cs.indexOf(c) + 1
            if (c.eleito && d > nVagas) arquivo.write("\n$d - $c")
        }
        //Impressão dos eleitos que não estão entre os nVagas-mais votados
        arquivo.write("\n\nEleitos, que se beneficiaram do sistema proporcional:")
        arquivo.write("\n(com sua posição no ranking de mais votados)")
        for (c in cs) {
            var d = cs.indexOf(c) + 1
            if (c.eleito && d > nVagas) arquivo.write("\n$d - $c")
        }
        //Impressão das coligações por ordem das mais votadas
        arquivo.write("\n\nVotação (nominal) das coligações e número de candidatos eleitos:")
        cls.sort()
        var i = 1
        for (c in cls){
            arquivo.write("\n$i - ${c.toString()}")
            i++
        }
        //Impressão dos partidos por ordem dos mais votados
        arquivo.write("\n\nVotação (nominal) dos partidos e número de candidatos eleitos:")
        ps.sort()
        i = 1
        for(p in ps){
            if(p.getVotos() != 0){
                arquivo.write("\n$i - ${p.toString()}")
                nVotos += p.getVotos()
                i++
            }
        }
    }//Fim da imprimeEleicao(OutputStreamWriter arquivo)
}