package eleicao
import kotlin.collections.*
class Partido(val nome:String):Comparable<Partido> {
    override fun compareTo(other: Partido): Int {
        if(this.getVotos() > other.getVotos()) return -1
        if(this.getVotos() < other.getVotos()) return 1
        return 0
    }

    val candidatos:MutableList<Candidato> = mutableListOf()

    fun getVotos():Int{
        var votos = 0
        for(c in this.candidatos)
            votos+= c.votos
        return votos
    }

    fun getEleitos():Int{
        var eleitos = 0
        for(c:Candidato in candidatos){
            if(c.eleito) eleitos++
        }
        return eleitos
    }

    override fun toString(): String {
        return "${this.nome}, ${this.getVotos()} votos, ${this.getEleitos()} candidatos eleitos"
    }
}